
CREATE OR REPLACE FUNCTION tcg.public.FN_before_insert_TCG_User_Relationship()
RETURNS TRIGGER AS $$
DECLARE
    r_change_set RECORD;
BEGIN
    NEW.created_on = COALESCE(NEW.created_on, CURRENT_TIMESTAMP);
    NEW.updated_last_on = COALESCE(NEW.updated_last_on, CURRENT_TIMESTAMP);

    IF NEW.change_set_id IS NULL THEN
		RAISE EXCEPTION 'Change Set ID must be provided.';
    END IF;

    SELECT *
    INTO r_change_set
    FROM tcg.public.TCG_Change_Set CHANGE_SET
    WHERE NEW.change_set_id = CHANGE_SET.change_set_id
    ;

    IF FOUND THEN
        NEW.created_by_user_id := COALESCE(NEW.created_by_user_id, r_change_set.updated_last_by_user_id);
        NEW.updated_last_by_user_id := COALESCE(NEW.updated_last_by_user_id, r_change_set.updated_last_by_user_id);
        NEW.created_on := COALESCE(NEW.created_on, r_change_set.updated_last_on);
    ELSE
        RAISE EXCEPTION 'Change Set % not found.', NEW.change_set_id;
    END IF;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql
;

CREATE OR REPLACE FUNCTION tcg.public.FN_before_update_TCG_User_Relationship()
RETURNS TRIGGER AS $$
BEGIN
    NEW.updated_last_on = CURRENT_TIMESTAMP;

    IF OLD.change_set_id IS NOT DISTINCT FROM NEW.change_set_id THEN
		RAISE EXCEPTION 'New Change Set ID must be provided.';
    END IF;

    INSERT INTO tcg.public.TCG_User_Relationship_Audit (
		  relationship_id
        , name_field
        , value_prev
        , value_new
        , change_set_id
    )
	-- Changed follower_user_id
	SELECT NEW.relationship_id, 'follower_user_id', OLD.follower_user_id::TEXT, NEW.follower_user_id::TEXT, NEW.change_set_id
		WHERE OLD.follower_user_id IS NOT DISTINCT FROM NEW.follower_user_id
	UNION
	-- Changed following_user_id
	SELECT NEW.relationship_id, 'following_user_id', OLD.following_user_id::TEXT, NEW.following_user_id::TEXT, NEW.change_set_id
		WHERE OLD.following_user_id IS NOT DISTINCT FROM NEW.following_user_id
	UNION
	-- Changed is_following
	SELECT NEW.relationship_id, 'is_following', OLD.is_following::TEXT, NEW.is_following::TEXT, NEW.change_set_id
		WHERE OLD.is_following IS NOT DISTINCT FROM NEW.is_following
	UNION
	-- Changed is_blocked
	SELECT NEW.relationship_id, 'is_blocked', OLD.is_blocked::TEXT, NEW.is_blocked::TEXT, NEW.change_set_id
		WHERE OLD.is_blocked IS NOT DISTINCT FROM NEW.is_blocked
	UNION
	-- Changed active
	SELECT NEW.relationship_id, 'active', OLD.active::TEXT, NEW.active::TEXT, NEW.change_set_id
		WHERE OLD.active IS NOT DISTINCT FROM NEW.active
    ;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql
;

CREATE TRIGGER TRI_before_insert_TCG_User_Relationship
    BEFORE INSERT ON tcg.public.TCG_User_Relationship
    FOR EACH ROW
    EXECUTE FUNCTION tcg.public.FN_before_insert_TCG_User_Relationship()
;
CREATE TRIGGER TRI_before_update_TCG_User_Relationship
    BEFORE UPDATE ON tcg.public.TCG_User_Relationship
    FOR EACH ROW
    EXECUTE FUNCTION tcg.public.FN_before_update_TCG_User_Relationship()
;